diff --git a/platform/xen/Makefile b/platform/xen/Makefile
index 14a131a3..b79a9167 100644
--- a/platform/xen/Makefile
+++ b/platform/xen/Makefile
@@ -31,10 +31,10 @@ endif
 RUMP_LIBS_PCI = -lrumpdev_pci -lrumpdev_pci_if_wm -lrumpdev_miiphy
 RUMP_LIBS_FS = -lrumpfs_ffs -lrumpfs_cd9660 -lrumpdev_disk -lrumpdev -lrumpvfs
 RUMP_LIBS_NET = -lrumpnet_config -lrumpdev_bpf -lrumpnet_xenif -lrumpnet_netinet
-RUMP_LIBS_NET+= -lrumpnet_net -lrumpxen_xendev -lrumpnet
+RUMP_LIBS_NET+= -lrumpnet_local -lrumpnet_net -lrumpxen_xendev -lrumpnet
 
 # Define some default flags for linking.
-RUMP_LDLIBS = --whole-archive ${RUMP_LIBS_FS} ${RUMP_LIBS_NET} ${RUMP_LIBS_PCI} ${RUMP_LIBS_SYSPROXY} -lrump --no-whole-archive
+RUMP_LDLIBS = --whole-archive ${RUMP_LIBS_FS} ${RUMP_LIBS_NET} ${RUMP_LIBS_PCI} ${RUMP_LIBS_SYSPROXY} -lrumpxen_tc -lrump --no-whole-archive
 RUMP_LDLIBS := ${RUMP_LDLIBS} -lpthread -lc
 
 LDFLAGS := -L$(abspath rump/lib)
diff --git a/platform/xen/buildxen.sh b/platform/xen/buildxen.sh
index 426463bb..a51bcd77 100755
--- a/platform/xen/buildxen.sh
+++ b/platform/xen/buildxen.sh
@@ -44,6 +44,7 @@ makekernlib ()
 make -C xen links
 makekernlib rumpxenif
 makekernlib rumpxendev
+makekernlib rumpxentc
 
 # build the domU image
 make || die make failed
diff --git a/platform/xen/lib/emul.c b/platform/xen/lib/emul.c
index 7b3fdc17..3ec0008d 100644
--- a/platform/xen/lib/emul.c
+++ b/platform/xen/lib/emul.c
@@ -14,7 +14,10 @@
 
 #include <errno.h>
 #include <fcntl.h>
+#include <lwp.h>
+#include <signal.h>
 #include <stdlib.h>
+#include <time.h>
 #include <unistd.h>
 
 #include <mini-os/os.h> /* for PAGE_SIZE */
@@ -108,3 +111,17 @@ _exit(int eval)
 	minios_stop_kernel();
 	minios_do_halt(MINIOS_HALT_POWEROFF);
 }
+
+int ____sigtimedwait50(const sigset_t *set, siginfo_t *info,
+		const struct timespec *timeout)
+{
+	int rc;
+	rc = _lwp_park(CLOCK_MONOTONIC, 0, timeout, NULL, NULL, NULL);
+	if (rc == -1) {
+		if (errno == ETIMEDOUT)
+			errno = EAGAIN;
+	} else {
+		errno = EAGAIN;
+	}
+	return -1;
+}
diff --git a/platform/xen/lib/libc_stubs.c b/platform/xen/lib/libc_stubs.c
index b1cb901d..973e4a69 100644
--- a/platform/xen/lib/libc_stubs.c
+++ b/platform/xen/lib/libc_stubs.c
@@ -34,4 +34,3 @@ STUB(_sys_msgsnd);
 STUB(_sys___msync13);
 STUB(_sys___wait450);
 STUB(_sys___sigsuspend14);
-STUB(____sigtimedwait50);
diff --git a/platform/xen/rumpxentc/Makefile b/platform/xen/rumpxentc/Makefile
new file mode 100644
index 00000000..bc5062e9
--- /dev/null
+++ b/platform/xen/rumpxentc/Makefile
@@ -0,0 +1,15 @@
+LIB=	rumpxen_tc
+
+SRCS+=	rumpxen_tc.c
+
+RUMPTOP= ${TOPRUMP}
+
+CPPFLAGS+=	-I${RUMPTOP}/librump/rumpkern -I${RUMPTOP}/librump
+CPPFLAGS+=	-I${.CURDIR} -I${.CURDIR}/../rump/include
+CPPFLAGS+=	-I${.CURDIR}/../xen/include -D__RUMP_KERNEL__ -I${.CURDIR}/..
+
+RUMP_SYM_NORENAME=xenbus_|HYPERVISOR_|minios_
+
+.include "${RUMPTOP}/Makefile.rump"
+.include <bsd.lib.mk>
+.include <bsd.klinks.mk>
diff --git a/platform/xen/rumpxentc/rumpxen_tc.c b/platform/xen/rumpxentc/rumpxen_tc.c
new file mode 100644
index 00000000..ee39022d
--- /dev/null
+++ b/platform/xen/rumpxentc/rumpxen_tc.c
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2015 Martin Lucina.  All Rights Reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
+ * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+#include <sys/param.h>
+#include <sys/cpu.h>
+#include <sys/kernel.h>
+#include <sys/module.h>
+#include <sys/timetc.h>
+
+#include <mini-os/time.h>
+
+MODULE(MODULE_CLASS_MISC, rumpxen_tc, NULL);
+
+static u_int
+rumpxen_tc_get(struct timecounter *tc)
+{
+	return (u_int)minios_clock_monotonic();
+}
+
+static struct timecounter rumpxen_tc = {
+	.tc_get_timecount	= rumpxen_tc_get,
+	.tc_poll_pps 		= NULL,
+	.tc_counter_mask	= ~0,
+	.tc_frequency		= 1000000000ULL,
+	.tc_name		= "rumpxen",
+	.tc_quality		= 100,
+};
+
+static int
+rumpxen_tc_modcmd(modcmd_t cmd, void *arg)
+{
+	switch (cmd) {
+	case MODULE_CMD_INIT:
+		tc_init(&rumpxen_tc);
+		break;
+
+	case MODULE_CMD_FINI:
+		tc_detach(&rumpxen_tc);
+		break;
+
+	default:
+	return ENOTTY;
+	}
+	return 0;
+}
